package cv1;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import org.lwjgl.*;
import org.lwjgl.glfw.*;
import org.lwjgl.opengl.*;
import org.lwjgl.system.*;

import java.nio.*;
import java.util.logging.Level;
import java.util.logging.Logger;

import static org.lwjgl.glfw.Callbacks.*;
import static org.lwjgl.glfw.GLFW.*;
import static org.lwjgl.opengl.GL11.*;
import static org.lwjgl.opengl.GL15.*;
import static org.lwjgl.opengl.GL20.*;
import static org.lwjgl.opengl.GL30.*;
import static org.lwjgl.system.MemoryStack.*;
import static org.lwjgl.system.MemoryUtil.*;

public class Cv1 {

    private static final float VERTICES[] = {
        // Triangle vertices
         0.0f,  0.6f,
        -0.4f,  0.2f,
         0.4f,  0.2f,

        // House vertices
        // Task 5:  add 6 vertices for the house
//         0.4f,  0.2f,
//        -0.4f,  0.2f,
//        -0.4f, -0.6f,
//
//         0.4f,  0.2f,
//        -0.4f, -0.6f,
//         0.4f, -0.6f,

        //Sun vertices (18 vertices)
        // Task 6:  add all vertices for the sun
//        -0.80f, 0.80f,      // Center
//        -0.80f, 0.95f,      // v1
//        -0.77f, 0.87f,      // v2
//        -0.70f, 0.90f,      // v3
//        -0.73f, 0.83f,      // v4
//        -0.65f, 0.80f,      // v5
//        -0.73f, 0.77f,      // v6
//        -0.70f, 0.70f,      // v7
//        -0.77f, 0.73f,      // v8
//        -0.80f, 0.65f,      // v9
//        -0.83f, 0.73f,      // v10
//        -0.90f, 0.70f,      // v11
//        -0.87f, 0.77f,      // v12
//        -0.95f, 0.80f,      // v13
//        -0.87f, 0.83f,      // v14
//        -0.90f, 0.90f,      // v15
//        -0.83f, 0.87f,      // v16
//        -0.80f, 0.95f,      // v1 - copy
    };

    private static final float COLORS[] = {
        // Task 4:  change values here to first make the triangle change between 3 basic colors, then to have it fade to black towards lower points
        1.0f, 0.0f, 0.0f,
        1.0f, 0.0f, 0.0f,
        1.0f, 0.0f, 0.0f,
        
        // Task 5:  add color for 6 vertices of the house
//        1.0f, 1.0f, 0.0f,
//        1.0f, 1.0f, 0.0f,
//        1.0f, 1.0f, 0.0f,
//        
//        1.0f, 1.0f, 0.0f,
//        1.0f, 1.0f, 0.0f,
//        1.0f, 1.0f, 0.0f,
        
        // Task 6:  add color for sun vertices
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
//        1.0f, 1.0f, 0.5f,
    };

    // The window handle
    private long window;

    // window size
    private int width;
    private int height;
    private boolean resized = false;
    
    // our OpenGL resources
    private int geometryBuffer;
    private int colorBuffer;
    private int geometryArray;
    
    // our GLSL resources
    private int program;
    private int positionAttribLoc;
    private int colorAttribLoc;

    public static void main(String[] args) {
        new Cv1().run();
    }
    
    public void run() {
        System.out.println("Hello LWJGL " + Version.getVersion() + "!");

        initGLFW();
        loop();

        // Free the window callbacks and destroy the window
        glfwFreeCallbacks(window);
        glfwDestroyWindow(window);

        // Terminate GLFW and free the error callback
        glfwTerminate();
        glfwSetErrorCallback(null).free();
    }

    private void initGLFW() {
        // Setup an error callback. The default implementation
        // will print the error message in System.err.
        GLFWErrorCallback.createPrint(System.err).set();

        // Initialize GLFW. Most GLFW functions will not work before doing this.
        if (!glfwInit()) {
            throw new IllegalStateException("Unable to initialize GLFW");
        }

        // Configure GLFW
        glfwDefaultWindowHints(); // optional, the current window hints are already the default
        glfwWindowHint(GLFW_VISIBLE, GLFW_FALSE); // the window will stay hidden after creation
        glfwWindowHint(GLFW_RESIZABLE, GLFW_TRUE); // the window will be resizable
        glfwWindowHint(GLFW_CONTEXT_VERSION_MAJOR, 3); // request the OpenGL 3.3 core profile context
        glfwWindowHint(GLFW_CONTEXT_VERSION_MINOR, 3);
        glfwWindowHint(GLFW_OPENGL_PROFILE, GLFW_OPENGL_CORE_PROFILE);

        // Create the window
        window = glfwCreateWindow(300, 300, "Hello World!", NULL, NULL);
        if (window == NULL) {
            throw new RuntimeException("Failed to create the GLFW window");
        }

        // Setup a key callback. It will be called every time a key is pressed, repeated or released.
        glfwSetKeyCallback(window, (window, key, scancode, action, mods) -> {
            if (key == GLFW_KEY_ESCAPE && action == GLFW_RELEASE) {
                glfwSetWindowShouldClose(window, true); // We will detect this in the rendering loop
            }
            // Task 9: flip value of drawWireframe when user presses the L key ('lines')
        });

        // add a size callback
        glfwSetWindowSizeCallback(window, (window, width, height) -> {
            this.width = width;
            this.height = height;
            resized = true;
        });
        
        // Get the thread stack and push a new frame
        try (MemoryStack stack = stackPush()) {
            IntBuffer pWidth = stack.mallocInt(1); // int*
            IntBuffer pHeight = stack.mallocInt(1); // int*

            // Get the window size passed to glfwCreateWindow
            glfwGetWindowSize(window, pWidth, pHeight);

            // Get the resolution of the primary monitor
            GLFWVidMode vidmode = glfwGetVideoMode(glfwGetPrimaryMonitor());

            // Center the window
            glfwSetWindowPos(
                    window,
                    (vidmode.width() - pWidth.get(0)) / 2,
                    (vidmode.height() - pHeight.get(0)) / 2
            );
        } // the stack frame is popped automatically

        // Make the OpenGL context current
        glfwMakeContextCurrent(window);
        // Enable v-sync
        glfwSwapInterval(1);

        // Make the window visible
        glfwShowWindow(window);
        
        // This line is critical for LWJGL's interoperation with GLFW's
        // OpenGL context, or any context that is managed externally.
        // LWJGL detects the context that is current in the current thread,
        // creates the GLCapabilities instance and makes the OpenGL
        // bindings available for use.
        GL.createCapabilities();
    }

    private void loop() {
        // Prepare data for rendering
        init();
        
        // Run the rendering loop until the user has attempted to close
        // the window or has pressed the ESCAPE key.
        while (!glfwWindowShouldClose(window)) {
            render();
            
            glfwSwapBuffers(window); // swap the color buffers

            // Poll for window events. The key callback above will only be
            // invoked during this call.
            glfwPollEvents();
        }
    }
    
    private void init() {
        // PV112 initialization
        // Task 1: change parameter values here to change the color of window's background
        glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
        
        // load GLSL program (vertex and fragment shaders)
        try {
            program = loadProgram("/resources/shaders/vertex.glsl",
                    "/resources/shaders/fragment.glsl");
        } catch (IOException ex) {
            Logger.getLogger(Cv1.class.getName()).log(Level.SEVERE, null, ex);
            System.exit(1);
        }

        // create buffers with geometry
        int[] buffers = new int[2];
        
        // Task 2:  create 2 OpenGL buffer using glGenBuffers(int[] buffers)
        //          store the first value of resulting array into geometryBuffer class variable
        //          set it as current GL_ARRAY_BUFFER using glBindBuffer(int target, int buffer)
        //          fill it with data from array VERTICES using glBufferData(int target, float[] data, int usage) where usage will be GL_STATIC_DRAW
        
        
        // Task 3:  store the second created buffer to colorBuffer class variable
        //          set it as current GL_ARRAY_BUFFER using glBindBuffer(int target, int buffer)
        //          fill it with data from array COLORS using glBufferData(int target, float[] data, int usage) where usage will be GL_STATIC_DRAW
        
        
        
        // clear buffer binding, so that other code doesn't presume it (easier error detection)
        glBindBuffer(GL_ARRAY_BUFFER, 0);

        // get attribute and uniform locations
        positionAttribLoc = glGetAttribLocation(program, "position");
        colorAttribLoc = glGetAttribLocation(program, "color");
        
        // create a vertex array object for the geometry
        // Task 2:  create VAO using glGenVertexArrays(), store the result to geometryArray class variable
        //          set it as current VAO using glBindVertexArray(int array)
        //          set geometryBuffer you created previously as current GL_ARRAY_BUFFER again using glBindBuffer (it is now the source of vertex data)
        //          enable reading data for "position" attribute during drawing using glEnableVertexAttribArray(int index)
        //              where index is positionAttribLoc acquired above
        //          set format of position data using glVertexAttribPointer(int index, int size, int type, false, 0, 0)
        //              where index is again positionAttribLoc, size is how many components our vectors have (2), type is type of one component (GL_FLOAT)
        
        
        // Task 3:  similarly to above set colorBuffer as source for "color" attribute
        //          you don't need to bind VAO again.
        //          what will be now the size and type of one vector?
        
    }

    private void render() {
        if (resized) {
            glViewport(0, 0, width, height);
            resized = false;
        }
        
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); // clear the framebuffer
        
        // Task 8:  try drawing only wireframe of the geometry using glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
        // Task 9:  change between GL_LINE and GL_FILL according to drawWireframe variable
        
        
        // Task 2:  set OpenGL program that is going to process our data using glUseProgram(int program) (it has been created in init)
        //          set VAO with our data as source for drawing using glBindVertexArray(int array)
        //          draw first 3 vertices of our array as a GL_TRIANGLES using glDrawArrays(int mode, int first, int count)
        // Task 5:  increase the number of drawn vertices to draw 2 additional triangles
        // Task 6:  draw next 18 vertices as GL_TRIANGLE_FAN using glDrawArrays
        // Task 7:  get "pointer" to uniform variable for aspect ratio from our shader using glGetUniformLocation(int program, CharSequence name) store it to int variable
        //          set value of that variable to (float)width/height using glUniform1f(int location, float value)
        
    }
    
    private int loadShader(String filename, int shaderType) throws IOException {
        String source = readAllFromResource(filename);
        int shader = glCreateShader(shaderType);
        
        // create and compile GLSL shader
        glShaderSource(shader, source);
        glCompileShader(shader);
        
        // check GLSL shader compile status
        int status = glGetShaderi(shader, GL_COMPILE_STATUS);
        if (status == GL_FALSE) {
            String log = glGetShaderInfoLog(shader);
            System.err.println(log);
        }
        
        return shader;
    }
    
    private int loadProgram(String vertexShaderFile, String fragmentShaderFile) throws IOException {
        // load vertex and fragment shaders (GLSL)
        int vs = loadShader(vertexShaderFile, GL_VERTEX_SHADER);
        int fs = loadShader(fragmentShaderFile, GL_FRAGMENT_SHADER);

        // create GLSL program, attach shaders and compile it
        int program = glCreateProgram();
        glAttachShader(program, vs);
        glAttachShader(program, fs);
        glLinkProgram(program);

        int status = glGetProgrami(program, GL_LINK_STATUS);
        if (status == GL_FALSE) {
            String log = glGetProgramInfoLog(program);
            System.err.println(log);
        }

        return program;
    }
    
    private String readAllFromResource(String resource) throws IOException {
        InputStream is = Cv1.class.getResourceAsStream(resource);
        if (is == null) {
            throw new IOException("Resource not found: " + resource);
        }

        BufferedReader reader = new BufferedReader(new InputStreamReader(is));
        StringBuilder sb = new StringBuilder();
        
        int c;
        while ((c = reader.read()) != -1) {
            sb.append((char) c);
        }

        return sb.toString();
    }
}
